#include "main.h"


/******************************************************************************
*
*    main()
*   
*****************************************************************************/  
int main()
{

  unsigned char next_char, cmd_ctr, cmd2_ctr;
  char hi_byte, lo_byte;
  unsigned char command_string[MAX_COMMAND_LENGTH];
  unsigned char periodic_on[MAX_ADC_SLAVES]={0}; //period of periodic requests
  unsigned char periodic_back_counter[MAX_ADC_SLAVES]={0}; //period of periodic requests
  char marad;
  unsigned char incr_50ms = 0; //is incremented every 50ms
  int i, j; //,k; //just general use variables
  unsigned char my_string[40]; //just to store random strings 
  unsigned char aa, ab, ac; //some "random use" variables

  init(); //initialize all periferals
  
  pause(200);
  serialout_insert_text( "NRL66 ADC Module Online");

  flash_LED = 1; //flash LED #0
  
  
  // main loop!!
  while(true)
    {

      //-----------------------------------------------
      //-----------------------------------------------
      // 50ms heart rate
      //-----------------------------------------------
      if(fifty_milli_second)
        {
	  fifty_milli_second = false;
	  incr_50ms++;
	  //making LED's flash
	  if(flash_LED)
	    {
	      if(!(incr_50ms%4)) //just to slow down flashing
		P2OUT ^= flash_LED;
	    }

	  for(i=0;i<nr_of_slaves;i++)
	    {
	      if(periodic_on[i]) //done in two steps to speed up process
		{
		  if(!(periodic_back_counter[i]))
		    {
		      //send report
		      I2C_nr_bytes=3;
		      if(!(I2C_Read_string(i+1)))
			{
			  aa=I2C_in_buffer[0];
			  ab=I2C_in_buffer[1];
			  ac=I2C_in_buffer[2];
                          #ifdef VERBOSE_RESPONSE
		          //sprintf(my_string,"PRS:%d OK %d %d %d",i,aa,ab,ac);
			  sprintf(my_string,"PRS:%d OK",i);
                          #endif
			  serialout_insert_startframe();
			  serialout_insert_char(RESPONSE_VALUES);
			  serialout_insert_char((unsigned char)seq_nr);
			  serialout_insert_char(i);
			  serialout_insert_char(aa);
			  serialout_insert_char(ab);
			  serialout_insert_char(ac);
			  serialout_insert_endframe();
			  seq_nr++;
			  seq_nr%=128;
			}
		      else
			{
                          #ifdef VERBOSE_RESPONSE
			  sprintf(my_string,"PRS:%d FAIL",i);
                          #endif
			}
                      #ifdef VERBOSE_RESPONSE
		      serialout_insert_text(my_string);
                      #endif

		      periodic_back_counter[i]=periodic_on[i];
		    }
		  periodic_back_counter[i]--;
		}
	    }
	}

      //-----------------------------------------------
      //-----------------------------------------------
      // POSSIBLE INCOMING COMMAND
      //-----------------------------------------------
      if(command_waiting) //we have received an END_FRAME
	{
	  command_waiting = false;
	  
	  //truncate the inbuffer until we find a START_FRAME
	  marad=true;
	  next_char = 0;
	  while(marad)
	    {
	      marad=serialin_get_char(&next_char);
	      if(next_char==START_FRAME)
		marad=false;
	    }

	  //we have found a START_FRAME
	  //let's see if there is a corresponding END_FRAME
	  if(next_char==START_FRAME)
	    {
	      marad=true;
	      next_char = 0;
	      cmd_ctr = 0;
	      while(marad)
		{
		  marad=serialin_peek_char(&next_char);
		  if(marad)
		    {
		      if(next_char==START_FRAME)
			marad=false;
		      else
			{
			  if(next_char != END_FRAME)
			    {
			      command_string[cmd_ctr]=next_char;
			      serialin_remove_head();
			      cmd_ctr++;
			    }
			  else
			    {
			      marad=false;
			    }
			}
		    }
		}
	    }
	  
	  //we have a command 
	  if(next_char == END_FRAME) //we were able to assemble a command
	    {
	      if(cmd_ctr==0) //this command has zero size, send Error
		{
		  serialout_SendError(ERROR_TYPE_GENERAL);
		}
	      else if(cmd_ctr&0x01) //command length is not even
		{ //we cannot de-hamming
		  serialout_SendError(ERROR_TYPE_GENERAL);;
		}
	      else
		{
		  //let's decode the command
		  for(cmd2_ctr=0;cmd2_ctr<cmd_ctr;cmd2_ctr+=2)
		    {
		      lo_byte=CodeToData(command_string[cmd2_ctr]);
		      hi_byte=CodeToData(command_string[cmd2_ctr+1]);
		      if((lo_byte==-1)
			 || (hi_byte==-1) )
			{  //we could not de-hamming
			  command_string[0] = 0; //this should cause an error below
			  cmd2_ctr=cmd_ctr; //exit the for loop
			}
		      else
			{
			  command_string[(cmd2_ctr>>1)]=(hi_byte<<4)+lo_byte;
			}
		    }
		  cmd_ctr/=2;

		  switch (command_string[0]) //let's parse the command
		    {
		      //|||||||||||||||||||||||||||||||||||||||||||||
		      //|||||||||||||||||||||||||||||||||||||||||||||
		    case COMMAND_HELLO:
		      if(cmd_ctr!=1)
			{
			  serialout_SendError(ERROR_TYPE_GENERAL);
			  break;
			}
		      #ifdef VERBOSE_RESPONSE
		      serialout_insert_text("HELLO");
		      #endif
		      serialout_SendOK(COMMAND_HELLO);
		      break;

		      //|||||||||||||||||||||||||||||||||||||||||||||
		      //|||||||||||||||||||||||||||||||||||||||||||||
		    case COMMAND_GET_VALUE:
		      if(cmd_ctr!=2)
			{
			  serialout_SendError(COMMAND_GET_VALUE);
			  break;
			}
		      i=command_string[1];
		      if(i!=255)
			{
			  if(i>nr_of_slaves)
			    {
			      serialout_SendError(COMMAND_GET_VALUE);
			      break;
			    }
			  I2C_nr_bytes=3;
			  if(!(I2C_Read_string(i+1)))
			    {
			      
			      aa=I2C_in_buffer[0];
			      ab=I2C_in_buffer[1];
			      ac=I2C_in_buffer[2];
                              #ifdef VERBOSE_RESPONSE
			      //sprintf(my_string,"RS:%d OK %d %d %d",i,aa,ab,ac);
			      sprintf(my_string,"RS:%d OK",i);
                              #endif
			      serialout_insert_startframe();
			      serialout_insert_char(RESPONSE_VALUES);
			      serialout_insert_char((unsigned char)seq_nr);
			      serialout_insert_char(i);
			      serialout_insert_char(aa);
			      serialout_insert_char(ab);
			      serialout_insert_char(ac);
			      serialout_insert_endframe();
			      seq_nr++;
			      seq_nr%=128;
			    }
			  else
			    {
                              #ifdef VERBOSE_RESPONSE
			      sprintf(my_string,"RS:%d FAIL",i);
			      #endif
			      serialout_SendError(COMMAND_GET_VALUE);
			    }
                          #ifdef VERBOSE_RESPONSE
			  serialout_insert_text(my_string);
                          #endif
			}//if(i!=255)
		      else
			{
			  for(i=0;i<nr_of_slaves;i++)
			    {
			      I2C_nr_bytes=3;
			      if(!(I2C_Read_string(i+1)))
				{
				  
				  aa=I2C_in_buffer[0];
				  ab=I2C_in_buffer[1];
				  ac=I2C_in_buffer[2];
                                  #ifdef VERBOSE_RESPONSE
				  sprintf(my_string,"RS:%d OK",i);
                                  #endif
				  serialout_insert_startframe();
				  serialout_insert_char(RESPONSE_VALUES);
				  serialout_insert_char((unsigned char)seq_nr);
				  serialout_insert_char(i);
				  serialout_insert_char(aa);
				  serialout_insert_char(ab);
				  serialout_insert_char(ac);
				  serialout_insert_endframe();
				  seq_nr++;
				  seq_nr%=128;
				}
			      else
				{
                                  #ifdef VERBOSE_RESPONSE
				  sprintf(my_string,"RS:%d FAIL",i);
			          #endif
				  serialout_SendError(COMMAND_GET_VALUE);
				}
                              #ifdef VERBOSE_RESPONSE
			      serialout_insert_text(my_string);
                              #endif
			    }//for number of slaves
			}//else (i==255)
		      break;

		      //|||||||||||||||||||||||||||||||||||||||||||||
		      //|||||||||||||||||||||||||||||||||||||||||||||
		    case COMMAND_GET_PERIODIC:
		      if(cmd_ctr!=3)
			{
			  serialout_SendError(COMMAND_GET_PERIODIC);
			  break;
			}
		      if(command_string[1]>nr_of_slaves)
			{
			  serialout_SendError(COMMAND_GET_PERIODIC);
			  break;
			}
		      serialout_SendOK(COMMAND_GET_PERIODIC);
		      periodic_on[command_string[1]] = 
			command_string[2];
		      break;

		      //|||||||||||||||||||||||||||||||||||||||||||||
		      //|||||||||||||||||||||||||||||||||||||||||||||
		    case COMMAND_SET_RATE:
		      if(cmd_ctr!=3)
			{
			  serialout_SendError(COMMAND_SET_RATE);
			  break;
			}
		      i=command_string[1];
		      if(i>nr_of_slaves)
			{
			  serialout_SendError(COMMAND_SET_RATE);
			  break;
			}
		      j = command_string[2];
		      I2C_out_buffer[0]=SLAVE_SET_RATE;
		      I2C_out_buffer[1]=j;
		      I2C_nr_bytes=3;
		      if(!(I2C_Write_string(i+1)))
			{
                          #ifdef VERBOSE_RESPONSE
			  sprintf(my_string,"SetRate:%d %d OK",i,j);
                          #endif
			  serialout_SendOK(COMMAND_SET_RATE);
			}
		      else
			{
                          #ifdef VERBOSE_RESPONSE
			  sprintf(my_string,"SetRate:%d %d FAIL",i,j);
                          #endif
			  serialout_SendError(COMMAND_SET_RATE);
			}
                      #ifdef VERBOSE_RESPONSE
		      serialout_insert_text(my_string);
		      #endif
		      break;
		    case COMMAND_SET_NR_CONV:
		      if(cmd_ctr!=3)
			{
			  serialout_SendError(COMMAND_SET_NR_CONV);
			  break;
			}
		      i=command_string[1];
		      if(i>nr_of_slaves)
			{
			  serialout_SendError(COMMAND_SET_NR_CONV);
			  break;
			}
		      j = command_string[2];
		      I2C_out_buffer[0]=SLAVE_SET_NR_CONV;
		      I2C_out_buffer[1]=j;
		      I2C_nr_bytes=3;
		      if(!(I2C_Write_string(i+1)))
			{
                          #ifdef VERBOSE_RESPONSE
			  sprintf(my_string,"SetNrCnv:%d %d OK",i,j);
			  #endif
			  serialout_SendOK(COMMAND_SET_NR_CONV);
			}
		      else
			{
                          #ifdef VERBOSE_RESPONSE
			  sprintf(my_string,"SetNrCnv:%d %d FAIL",i,j);
                          #endif
			  serialout_SendError(COMMAND_SET_NR_CONV);
			}
                      #ifdef VERBOSE_RESPONSE
		      serialout_insert_text(my_string);
		      #endif
		      break;

		      //|||||||||||||||||||||||||||||||||||||||||||||
		      //|||||||||||||||||||||||||||||||||||||||||||||
		    case COMMAND_SET_SINGLE_RUN:
		      if(cmd_ctr!=2)
			{
			  serialout_SendError(COMMAND_SET_SINGLE_RUN);
			  break;
			}
		      i=command_string[1];
		      if(i>nr_of_slaves)
			{
			  serialout_SendError(COMMAND_SET_SINGLE_RUN);
			  break;
			}
		      I2C_out_buffer[0]=SLAVE_SET_SINGLE;
		      I2C_nr_bytes=3;
		      if(!(I2C_Write_string(i+1)))
			{
                          #ifdef VERBOSE_RESPONSE
			  sprintf(my_string,"SetSingl:%d OK",i);
			  #endif
			  serialout_SendOK(COMMAND_SET_SINGLE_RUN);
			}
		      else
			{
                          #ifdef VERBOSE_RESPONSE
			  sprintf(my_string,"SetSingl:%d FAIL",i);
			  #endif
			  serialout_SendError(COMMAND_SET_SINGLE_RUN);
			}
                      #ifdef VERBOSE_RESPONSE
		      serialout_insert_text(my_string);
                      #endif
		      break;

		      //|||||||||||||||||||||||||||||||||||||||||||||
		      //|||||||||||||||||||||||||||||||||||||||||||||
		    case COMMAND_SET_CONTINOUS_RUN:
		      if(cmd_ctr!=2)
			{
			  serialout_SendError(COMMAND_SET_CONTINOUS_RUN);
			  break;
			}
		      i=command_string[1];
		      if(i>nr_of_slaves)
			{
			  serialout_SendError(COMMAND_SET_CONTINOUS_RUN);
			  break;
			}
		      I2C_out_buffer[0]=SLAVE_SET_CONTINOUS;
		      I2C_nr_bytes=3;
		      if(!(I2C_Write_string(i+1)))
			{
                          #ifdef VERBOSE_RESPONSE
			  sprintf(my_string,"SetCont:%d OK",i);
                          #endif
			  serialout_SendOK(COMMAND_SET_CONTINOUS_RUN);
			}
		      else
			{
                          #ifdef VERBOSE_RESPONSE
			  sprintf(my_string,"SetCont:%d FAIL",i);
                          #endif
			  serialout_SendError(COMMAND_SET_CONTINOUS_RUN);
			}
                      #ifdef VERBOSE_RESPONSE
		      serialout_insert_text(my_string);
		      #endif
		      break;

		      //|||||||||||||||||||||||||||||||||||||||||||||
		      //|||||||||||||||||||||||||||||||||||||||||||||
		    case COMMAND_SET_SLAVE_RESET:
		      if(cmd_ctr!=2)
			{
			  serialout_SendError(COMMAND_SET_SLAVE_RESET);
			  break;
			}
		      i=command_string[1];
		      if(i>nr_of_slaves)
			{
			  serialout_SendError(COMMAND_SET_SLAVE_RESET);
			  break;
			}
		      I2C_out_buffer[0]=SLAVE_SET_RESET;
		      I2C_nr_bytes=3;
		      if(!(I2C_Write_string(i+1)))
			{
                          #ifdef VERBOSE_RESPONSE
			  sprintf(my_string,"SetRst:%d OK",i);
			  #endif
			  serialout_SendOK(COMMAND_SET_SLAVE_RESET);
			}
		      else
			{
                          #ifdef VERBOSE_RESPONSE
			  sprintf(my_string,"SetRst:%d FAIL",i);
			  #endif
			  serialout_SendError(COMMAND_SET_SLAVE_RESET);
			}
                      #ifdef VERBOSE_RESPONSE
		      serialout_insert_text(my_string);
		      #endif
		      break;

		      //|||||||||||||||||||||||||||||||||||||||||||||
		      //|||||||||||||||||||||||||||||||||||||||||||||
		    case COMMAND_TRIGGER_ADCS:
		      if(cmd_ctr!=1)
			{
			  serialout_SendError(COMMAND_TRIGGER_ADCS);
			  break;
			}
		      if(!nr_of_slaves)
			{
			  serialout_SendError(COMMAND_TRIGGER_ADCS);
			  break;
			}
		      P3OUT |= 0x01;
		      for(j=0;j<TRIGGER_CYCLES;j++) i++;
		      P3OUT &= ~0x01;
		      serialout_SendOK(COMMAND_TRIGGER_ADCS);
                      #ifdef VERBOSE_RESPONSE
		      serialout_insert_text( "Triggered");
		      #endif
		      break;

		      //|||||||||||||||||||||||||||||||||||||||||||||
		      //|||||||||||||||||||||||||||||||||||||||||||||
		    case COMMAND_PROG_SLAVES: //Programming Slave ADC MSP430s
		      if(cmd_ctr!=2)
			{
			  serialout_SendError(COMMAND_PROG_SLAVES);
			  break;
			}
		      if(command_string[1]>MAX_ADC_SLAVES)
			{
			  serialout_SendError(COMMAND_PROG_SLAVES);
			  break;
			}
		      nr_of_slaves = command_string[1];
		      serialout_insert_text( "Programming Slaves");
		      for(i=0;i<nr_of_slaves;i++)
			{
			  //i = 0x01<<i; //address slaves without a demultiplexer
			  P1OUT = i; 
			  I2C_out_buffer[0]=i+1;
			  I2C_nr_bytes=1;
			  if(!(I2C_Write_string(0)))
			    {
                              #ifdef VERBOSE_RESPONSE
			      sprintf(my_string,"PS:%d OK",i);
			      #endif
			      serialout_SendOK(COMMAND_PROG_SLAVES);
			    }
			  else
			    {
                              #ifdef VERBOSE_RESPONSE
			      sprintf(my_string,"PS:%d FAIL",i);
			      #endif
			      serialout_SendError(COMMAND_PROG_SLAVES);
			    }
                          #ifdef VERBOSE_RESPONSE
			  serialout_insert_text(my_string);
                          #endif
			}
		      P1OUT = 0x80; //disable demultiplexer 
		      break;

		      //|||||||||||||||||||||||||||||||||||||||||||||
		      //|||||||||||||||||||||||||||||||||||||||||||||
		    default:
		      serialout_SendError(ERROR_TYPE_GENERAL);
		      break;
		    }//end of switch (command_string[0])
		}
	    }//end of if (next_char == END_FRAME)
	}
    }      // WHILE 1 MAIN LOOP
  return 0;
}

